clear all
close tables all
clear

*---> La table ERREURS doit tre ouverte en exclusif sur une autre tche
*---> Ouverture de la table ERREURS
*---> Renvoie .F. car la table est utilise en exclusif
?"OuvreTable 1 :", OuvreTable("erreurs.dbf", "ERREURS1")
wait

*---> Ouverture de la table ERREUR (qui n'existe pas)
*---> Renvoie .F. de la mme manire
?"OuvreTable 2 :", OuvreTable("erreur.dbf", "ERREURS2")

function OuvreTable(cDbf   as String, ;
                    cAlias as String) as Logical
local cOnError
  m.cOnError = On("error")
  on error *
  *---> On ne contrle pas les erreurs qui peuvent ce produire sur cette ligne
  use (m.cDbf) alias (m.cAlias) shared again
  on error &cOnError
  return Used(m.cAlias)
endfunc && OuvreTable