clear

try
  Main()
catch to m.oErr
    ?"Error: ", m.oErr.ErrorNo
    ?"LineNo: ", m.oErr.LineNo
    ?"Message: ", m.oErr.Message
    ?"Procedure: ", m.oErr.Procedure
    ?"Details: ", m.oErr.Details
    ?"StackLevel: ", m.oErr.StackLevel
    ?"LineContents: ", m.oErr.LineContents
    ?
    *---> UserValue contient l'objet OutlookException qui est remont
    ?"UserValue.Class: ", m.oErr.UserValue.Class
    ?"UserValue.Error: ", m.oErr.UserValue.ErrorNo
    ?"UserValue.LineNo: ", m.oErr.UserValue.LineNo
    ?"UserValue.Message: ", m.oErr.UserValue.Message
    ?"UserValue.Procedure: ", m.oErr.UserValue.Procedure
    ?"UserValue.Details: ", m.oErr.UserValue.Details
    ?"UserValue.StackLevel: ", m.oErr.UserValue.StackLevel
    ?"UserValue.LineContents: ", m.oErr.UserValue.LineContents
    ?"UserValue.UserValue: ", m.oErr.UserValue.UserValue
endtry

procedure Main()
  PrepareOutlook()  
endproc && Main


procedure PrepareOutlook()
  try
     m.oOutlook = CreateObject("Outlook.Application")
  catch to m.oErr
    *---> On fait remonter un objet OutlookException
    throw CreateObject("OutlookException")
  endtry
endproc && PrepareOutlook

define class AlertException as Exception

  procedure Init()
    MessageBox(this.Message, 16, "Erreur critique")
  endproc && Init
  
enddefine && CriticalException


define class OutlookException as AlertException

  ErrorNo = 5001
  Message = "Outlook n'est pas install sur la machine"
  
enddefine && OutlookException