clear all
close tables all
clear

*---> La table ERREURS doit tre ouverte en exclusif sur une autre tche

*---> Renvoie .F. car la table est utilise en exclusif
?"1 - OuvreTable :", OuvreTable("erreurs.dbf", "ERREUR2")
wait

*---> Renvoie .F. de la mme manire car la table ERREUR n'existe pas
?"2 - OuvreTable :", OuvreTable("erreur.dbf", "ERREUR2")
wait

*---> Renvoie .F. car la table est utilise en exclusif
?"3 - OuvreTable2 :", OuvreTable2("erreurs.dbf", "ERREUR2")
wait

*---> Erreur car la table ERREUR n'existe pas
?"4 - OuvreTable2 :", OuvreTable2("erreur.dbf", "ERREUR2")


function OuvreTable(cDbf   as String, ;
                    cAlias as String) as Logical
local cOnError
  m.cOnError = On("error")
  on error *
  *---> On ne contrle pas les erreurs qui peuvent ce produire sur cette ligne
  use (m.cDbf) alias (m.cAlias) shared again
  on error &cOnError
  return Used(m.cAlias)
endfunc && OuvreTable

function OuvreTable2(cDbf   as String, ;
                     cAlias as String) as Logical
local lOuverte
  try
    use (m.cDbf) alias (m.cAlias) shared again
    m.lOuverte = .T.
  *---> Le programme passe dans ce CATCH uniquement en cas
  *---> d'erreur 1705 "File access is denied."
  catch to oErr when oErr.ErrorNo = 1705
    m.lOuverte = .F.
  catch to oErr
    MessageBox(oErr.Message, 16, "Erreur critique")
    cancel
  endtry
  return m.lOuverte
endfunc && OuvreTable2