public goGestError
m.goGestError = CreateObject("GestError")
on error m.goGestError.OnError()

?OuvreTable("agenda.dbf")
*?1 = "b"

clear all
release all

function OuvreTable(cDbf as String) as Logical
local lOuverte
  try
    use (m.cDbf)
    m.lOuverte = .T.
  catch to oErr when oErr.ErrorNo = 1705
    m.lOuverte = .F.
  catch to oErr
    m.goGestError.Throw(m.oErr)
  endtry
  return m.lOuverte
endfunc && OuvreTable



define class GestError as Custom
  
  hidden LastException
  LastException = null

  procedure Throw(oErr as Exception)
    with this
      *---> On stocke l'erreur releve dans la proprit LastException
      .LastException = m.oErr
      throw m.oErr
    endwith
  endproc && Throw
  
  procedure OnError()
    with this
      *---> L'erreur provient d'un objet Exception
      if !IsNull(.LastException)
        ?.LastException.Message
      *---> Autre erreur
      else
        ?Message()
      endif
      cancel
    endwith
  endproc && OnError
  
enddefine && ErrorMapping